/*
**	mod_test.c	
**
**
** Copyright (c) 2001  Hughes Technologies Pty Ltd
**
** Permission to use, copy, and distribute for non-commercial purposes,
** is hereby granted without fee, providing that the above copyright
** notice appear in all copies and that both the copyright notice and this
** permission notice appear in supporting documentation.
**
** The software may be modified for your own purposes, but modified versions
** may not be distributed.
**
** This software is provided "as is" without any expressed or implied warranty.
**
*/


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <ember.h>
#include <ember-config.h>

#include "mod_test.h"



/**************************************************************************
** Routines that are private to this module
*/

static int myAdd(v1, v2)
	int	v1,
		v2;
{
	return(v1 + v2);
}


/**************************************************************************
** Routines that are exported as raw methods from this module
*/

void modTestMyInc(val, ptr)
	int	val;
	void	*ptr;
{
	int	*res = (int*)ptr;
	*res = val + 1;
}

/**************************************************************************
** Routines that are callable from script code
*/

int doTestOne(script, args)
	ember	*script;
	e_stack	*args;
{
	printf("Arg is '%s'\n", emTextArg(args));
	eDynamicSetIntValue(script,&script->returnValue, 0);
	return(0);
}


int doTestTwo(script, args)
	ember	*script;
	e_stack	*args;
{
	int	val1,
		val2,
		res;

	val1 = emIntArg(args); 
	val2 = emIntArg(args->next);
	res = myAdd(val1, val2);
	eDynamicSetIntValue(script,&script->returnValue, res);
	return(0);
}


int doTestThree(script, args)
	ember	*script;
	e_stack	*args;
{
	eDynamicSetError(script, EMBER_TYPE_INT, "Some error message");
	return(0);
}



int doTestFour(script, args)
	ember	*script;
	e_stack	*args;
{
	/* This has no args */
	printf("Functions 'testFour' in mod_test called!\n");
	return(0);
}


int init_mod(script, modPtr)
	ember	*script;
        void    *modPtr;
{ 
	if (modPtr)
	{
        	if (eDynamicAddModule(script, modPtr, test_externs) < 0)
        	{
                	return(-1);
        	}
	}
	if (eDynamicCreateIntMacro(script, "MY_MACRO", 1) <0)
	{
		return(-1);
	}
	return(0);
}

