/*
**	mod_test.h	- 
**
**
** Copyright (c) 2001  Hughes Technologies Pty Ltd.
**
** Permission to use, copy, and distribute for non-commercial purposes,
** is hereby granted without fee, providing that the above copyright
** notice appear in all copies and that both the copyright notice and this
** permission notice appear in supporting documentation.
**
** The software may be modified for your own purposes, but modified versions
** may not be distributed.
**
** This software is provided "as is" without any expressed or implied warranty.
**
*/




/*
** External function prototypes
*/

int doTestOne();
int doTestTwo();
int doTestThree();
int doTestFour();

/*
** Note : As this is a dynamic loading module (rather than a static
** linked module) we don't need the function pointer field to be
** completed.  It will be filled at run-time as the module is loaded
** into Lite's process address space.
*/

/*
** Process related module function definitions
**
** This table maps from internal Ember function names to the C code.
** The format is :-
**
**	{EName, CFunctPtr, CFunctName, NumArgs, { Arg1Type, Arg2Type.., 0}}
**
**	Setting NumArgs to -1 indicates varargs
*/


static e_extern test_externs[] = {
	{ "testOne", doTestOne, "_doTestOne", 1, { EMBER_TYPE_TEXT } },
	{ "testTwo", doTestTwo, "_doTestTwo", 2, 
			{ EMBER_TYPE_INT,EMBER_TYPE_INT,0}},
	{ "testThree", doTestThree, "_doTestThree", 0, { 0}},
	{ "testFour", doTestFour, "_doTestFour", 0, { 0}},

	{ NULL, 0 }
};
